
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java中String的hash函数分析 / iVAN</title>

    <meta name="description" content="Java中String的hash函数分析 JDK6的源码: /** * Returns a hash code for this string. The hash code for a * &lt;code&gt;String&lt;/code&gt; object is computed as * &lt;blockquote&gt;&lt;pre&gt; * s[0]*31^(n-1) + s[1]*31^(n-2) + ... + s[n-1] * &lt;/pre&gt;&lt;/blockquote&gt; * using & ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java中String的hash函数分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>JDK6的源码：</p>
<pre>    /**
     * Returns a hash code for this string. The hash code for a
     * &lt;code&gt;String&lt;/code&gt; object is computed as
     * &lt;blockquote&gt;&lt;pre&gt;
     * s[0]*31^(n-1) + s[1]*31^(n-2) + ... + s[n-1]
     * &lt;/pre&gt;&lt;/blockquote&gt;
     * using &lt;code&gt;int&lt;/code&gt; arithmetic, where &lt;code&gt;s[i]&lt;/code&gt; is the
     * &lt;i&gt;i&lt;/i&gt;th character of the string, &lt;code&gt;n&lt;/code&gt; is the length of
     * the string, and &lt;code&gt;^&lt;/code&gt; indicates exponentiation.
     * (The hash value of the empty string is zero.)
     *
     * @return  a hash code value for this object.
     */
    public int hashCode() {
	int h = hash;
	if (h == 0) {
	    int off = offset;
	    char val[] = value;
	    int len = count;

            for (int i = 0; i &lt; len; i++) {
                h = 31*h + val[off++];
            }
            hash = h;
        }
        return h;
    }</pre>
<p>以字符串"123"为例：</p>
<p>字符'1'的ascii码是49</p>
<p>hashCode = （49*31 + 50）*31 + 51</p>
<p>或者这样看：</p>
<p>hashCode=（'1' * 31 + '2' ） * 31 + '3'</p>
<p>可见实际可以看作是一种权重的算法，在前面的字符的权重大。</p>
<p>这样有个明显的好处，就是前缀相同的字符串的hash值都落在邻近的区间。</p>
<p>好处有两点：</p>
<p>1.可以节省内存，因为hash值在相邻，这样hash的数组可以比较小。比如当用HashMap，以String为key时。</p>
<p>2.hash值相邻，如果存放在容器，比好HashSet，HashMap中时，实际存放的内存的位置也相邻，则存取的效率也高。（程序局部性原理）</p>
<p>以31为倍数，原因了31的二进制全是1，则可以有效地离散数据。</p>
<p>最后看下，两个字符串，由Eclipse生成的代码是如何计算hash值的：</p>
<pre>public class Name{
	String firstName;
	String lastName;
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((firstName == null) ? 0 : firstName.hashCode());
		result = prime * result
				+ ((lastName == null) ? 0 : lastName.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Name other = (Name) obj;
		if (firstName == null) {
			if (other.firstName != null)
				return false;
		} else if (!firstName.equals(other.firstName))
			return false;
		if (lastName == null) {
			if (other.lastName != null)
				return false;
		} else if (!lastName.equals(other.lastName))
			return false;
		return true;
	}
}</pre>
<p>可见，还是以31为倍数， hashCode = firstName.hashCode() * 31 + lastName.hashCode() 。</p>
<p>BTW：Java的字符串的hash做了缓存，第一次才会真正算，以后都是取缓存值。</p>
<p>eclipse生成的equals函数质量也很高，各种情况都考虑到了。</p>
<p><strong>总结：字符串hash函数，不仅要减少冲突，而且要注意相同前缀的字符串生成的hash值要相邻。</strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 02:44:18</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java中String的hash函数分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1RZ0b.html" rel="bookmark">区分java中String&plus;String和String&plus;char&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们来考虑一个关于java中String的问题: &quot;abc&quot; + '/'和 &quot;abc&quot; + &quot;/&quot;的区别. 通过这个例子, 我们可以顺便练习一下JDK工具中javap的用法, 原问题是这样的: 把斜杠/当作字符或字符串有什么区别呢? 一个是当作基本数据类型char,一个是对象String.具体有什么区别呢? 当作字符效率会更高吗?String str = &quot;abc&quot; + '/';和String str = &quot;abc&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bolw3DM.html" rel="bookmark">java中 String类常量池</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java中 String类常量池 String常量池详解: 1.String使用private final char value[]来实现字符串的存储,也就是说String对象创建之后,就不能再修改此对象中存储的字符串内容,就是因为如此,才说String类型是不可变的(immutable).String类有一个特殊的创建方法,就是使用&quot;&quot;双引号来创建.例如new String(&quot;i am&quot;)实际创建了2个 String对象,一个是&quot;i am&quot;通过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKBEOp.html" rel="bookmark">java中String的一些方法深入解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下是对java中String的一些方法进行了详细的分析介绍,需要的朋友可以参考下   1.public String(char[] c,begin,length).从字符数组c的下标begin处开始,将长度为length的字符数组转换为字符串. begin与length可以省略,即将字符数组c转换为字符串.另:字符数组可改为字节数组byte[] b.char[] c=new char[]{'j','y','6','a','4','t','9'}; String s1=new String(c)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlByvnz.html" rel="bookmark">JAVA学习（六）：JAVA中的继承及其常见问题分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JAVA中的继承及其常见问题分析 1.JAVA中继承的定义 JAVA中,类的继承是通过扩展其他类而形成新类来实现的,原来的类称为父类(Super Class)或基类,新的类称为原来类的子类或派生类.在子类中,不仅包含了父类的属性和方法,还可以增加新的属性和方法,从而使得父类的基本特征可被所有子类对象共享. 注:类的继承并不改变类成员的访问权限,也就是说,如果父类的成员是公有的.被保护的或默认的,它的子类仍具有相应的这些特性. /**********************************			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6ky6b.html" rel="bookmark">java 中 String&period;indexOf&lpar;string&rpar; 就是找不到，明明存在在文件中 。求助？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java 中 String.indexOf(string) 就是找不到,明明存在在文件中 .求助? 我从网站或文件中读取一个文档,存储在一个String str中:比如此时我要查找一个 子字符串 substr 用 indexOf方法返回的为-1 但是在str中确实存在substr 在记事本或网页中可以查找到.把str 输出到console中也是存在 substr的求帮忙分析下原因?解决方法?谢谢 解决方案 大小写.全角半角.隐藏的空格或者特殊字符等细节检查下,还有,访问的是不是你期待的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YY7vM.html" rel="bookmark">string-关于java中String类型参数传递的问题，谁能给我讲清楚</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于java中String类型参数传递的问题,谁能给我讲清楚 我知道java里面参数传递是值传递,这点不用给我解释了.但是: import java.util.*; public class Test { public static void change(String s){ s=&quot;2&quot;; } public static void main(String[] args) throws Exception{ String s=&quot;1&quot;; change(s);			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7VLrz.html" rel="bookmark">字符串-java中String究竟是传递的值，还是引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java中String究竟是传递的值,还是引用 很多人说,java中的String虽然是对象,但是具有值类型的特征.他是值传递,传递的值. 我认为这这种说法完全是错误的. String和普通对象毫无区别,和其他对象一样,传递的是引用,而不是值. 一段String的运用代码: String a = &quot;123&quot;; public void change(String a){ a = &quot;234&quot;; } 很多人会说,a的值没有变,是因为String是值传递,问题是,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjLoq6p.html" rel="bookmark">asp&period;net中如何编写hash函数计算中文的hash值使之生成二进制数01</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 asp.net中如何编写hash函数计算中文的hash值使之生成二进制数01 asp.net中如何编写hash函数计算中文的hash值使之生成二进制数01 解决方案 产生16进制数,每一位都可以查表得到特定的4位二进制数. 解决方案二: &quot;使之生成二进制数01&quot;是什么意思?一般来说有中文的固定编码和hash函数就可以生成hash了 解决方案三: 给你个样子吧 using System; using System.Security.Cryptography; namespace			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWadnz.html" rel="bookmark">Java中String类型能转成int类型吗</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Java中String类型能转成int类型吗 一个String字符串 能否像 char类型一样 转换成int值 如果可以Java中怎么写 解决方案 看你用什么预言,各种预言都有转换函数,只要符合数值型,就可以正常转换 解决方案二: double?d?=?1.233; String?s1?=?String.valueOf(d); String?s2?=?s1.substring(0,?s1.indexOf(&quot;.&quot;))?+?s1.substring(s1.indexOf(&quo			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOPykb.html" rel="bookmark" class="title">我是如何让网站赢在起点的</a>
					<div>
						上个月做的一个藏獒配种信息网,现在刚上线百度收录11,外链60,即达到了站长网百度流量预计66的成绩,主关键词排名全部在百度前三,如图: 从以往的经历来看,新站上线就可以达到这样的效果,是非常不容易的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2orZM.html" rel="bookmark" class="title">如何创建简单的皮克斯场景</a>
					<div>
						效果图: 草图: 我在此提醒一下初学者,你如果有什么想做的东西,首先画草图.画画是表现你的思想的最直接方式.我开始画我的角色了,不过我还是只会画圆.然后把它们涂上不同的颜色.(图01) 图01					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW17Jjz.html" rel="bookmark" class="title">网页设计中几个不常用的HTML标签</a>
					<div>
						介绍几个不常用的HTML标签 在HTML王国里,这里有很多子民,通常我们看到的是一些熟悉的面孔,而对于那些不熟悉的面孔你又了解多少呢,你知道它们的用法吗? 0.&lt;!DOCTYPE&gt; 标签  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jPgZb.html" rel="bookmark" class="title">百度输入法怎么发送位置信息</a>
					<div>
						  现在,百度输入法也能发送位置信息啦!今天,小编就来跟大家分享百度输入法发送位置信息图文步骤,希望能对大家有所帮助. 第一步我们在自己手机上找到并点击打开百度输入法,然后进入到我们输入法管理窗后,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2q2yM.html" rel="bookmark" class="title">妙用WPS演示制作逻辑关系图</a>
					<div>
						我们在编辑电子教案或制作课件时经常需要用图表来表示知识点之间的逻辑关系(如图1),利用WPS演示的基本绘图功能可以轻松完成逻辑关系图的制作.下面就以图1中所示图表的制作为例,介绍一下具体作法. 图1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd79wAM.html" rel="bookmark" class="title">word2013如何删除页眉横线</a>
					<div>
						  word2013删除页眉横线的步骤如下: 步骤一:我们开始菜单下,点击格式右下角的箭头. 步骤二:在弹出的对话框里选择页眉 步骤三:点击&quot;修改&quot;,并在接下来的对话框里选择格式  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8RaRb.html" rel="bookmark" class="title">Lightroom教程：解决校正镜头的扭曲问题</a>
					<div>
						你是否曾经拍摄过市区的一些建筑,它们看起来好像是向后倾斜的?或者可能是建筑物的顶部看起来比底部宽?这些类型的镜头扭曲其实相当普遍,但在 Lightroom 以前版本中,要修复这些问题,必须转到Phot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArGrvp.html" rel="bookmark" class="title">USB键盘无法识别，无法使用</a>
					<div>
						故障现象: USB键盘无法使用,插入键盘后电脑检测不到,也不出现叹号设备,替换电脑测试USB盘正常. 原因分析: 仔细观察人体学输入设备中有两个设备,通过硬件id确认其中USB 输入设备是鼠标,上面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG3orp.html" rel="bookmark" class="title">新浪微博什么是短链分析？</a>
					<div>
						  短链分析是针对企业微博发布内容(原创+转发)中带有短链的点击量进行的统计.目前统计为点击量在前50名的微博,如带有短链的微博数不足50条则显示全部带有短链的微博按点击量进行排序.如果点击量相同,按 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYkZrM.html" rel="bookmark" class="title">eclipse生成【带有外部jar包】的java可执行jar包</a>
					<div>
						之前有写过一篇使用eclipse生成java可执行jar包,但是最近的一次使用中无论如何都不成功,当双击执行打成的jar时,弹出如下错误: could not find the main class: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72KKZp.html" rel="bookmark" class="title">学生信息管理系统&mdash;&mdash;配置windows防火墙允许访问SQL Server 2008服务器</a>
					<div>
						问题描述:       我在做学生管理系统的时候,Windows防火墙一直是关着的,在另一台电脑上运行的学生管理系统的时候可以顺利的登录,但是当把Windows防火墙打开之后,再运行系统,就无法进入了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My337lz.html" rel="bookmark" class="title">sql-ERP中，工厂日历主键的设置</a>
					<div>
						问题描述 ERP中,工厂日历主键的设置 我想问一下,工厂日历表的主键应该设置哪些项. 现在表里有:年份.计划期.开始日期.结束日期.备注. 我想着,如果主键设置成年份.计划期.开始日期 三项的话,会不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPX28p.html" rel="bookmark" class="title">java jar 运行自动重启 linux</a>
					<div>
						Js代码   echo &quot;Current DIR is &quot; $PWD     # ignore signal hup int quit tstp   trap &quot;&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2N4qb.html" rel="bookmark" class="title">android上传图片到服务器（使用base64字节流的形式通过 AsyncHttpClient框架传输）</a>
					<div>
						转自:http://blog.csdn.net/wolaizhaomengxiang/article/details/22721779 AsyncHttpClient  是一个框架提供的库  可以异步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kQ13M.html" rel="bookmark" class="title">C&plus;&plus;11中变参数模版和变参数宏混用的问题</a>
					<div>
						问题描述 C++11中变参数模版和变参数宏混用的问题 定义了一个模版,模版参数定义为可变,想通过宏来实例化,可变的模板参数也通过宏来传递,初步的实现及测试代码如下: #include &lt;QCor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QKyAp.html" rel="bookmark" class="title">通过ES2007平台开发生成的代码是JAVA的吗？</a>
					<div>
						问题描述 通过ES2007平台开发生成的代码是JAVA的吗? 解决方案 开发工具不是代码生成工具,而是图形化设计开发工具,简单来说,平台有一个强大的解释引擎,在设计时设计的业务逻辑在运行时被引擎解释并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kw2NM.html" rel="bookmark" class="title">在Eclipse中使用JUnit</a>
					<div>
						这篇文章将向你介绍Junit,一个用来在项目中进行测试和调试的工具.在介绍完TDD(以测试驱动开发)理论后,将进一步讲解怎样在流行的Eclipse中建立你自己的JUnit测试.向你展示如何测试Hell ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlG67p.html" rel="bookmark" class="title">我的MYSQL学习心得（十）</a>
					<div>
						原文:我的MYSQL学习心得(十) 我的MYSQL学习心得(十)   我的MYSQL学习心得(一) 我的MYSQL学习心得(二) 我的MYSQL学习心得(三) 我的MYSQL学习心得(四) 我的MYS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBL5GM.html" rel="bookmark" class="title">javascript-用JS写的计算器 如何进行加减乘除四则运算  求指教</a>
					<div>
						问题描述 用JS写的计算器 如何进行加减乘除四则运算 求指教 本人初学者 希望在我的基础上改动下 我的代码如下 还有 我做的小数点有问题 帮我看看 JiSuanQi &lt;!-- 移动层外部JS文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rQP0z.html" rel="bookmark" class="title">server2012R2 dfs同步出现错误 如图  求解？</a>
					<div>
						问题描述 server2012R2 dfs同步出现错误 如图 求解?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60q4yz.html" rel="bookmark" class="title">广电总局推&OpenCurlyDoubleQuote;限播令&rdquo;电视剧一天只能放两集</a>
					<div>
						&lt;我的团长我的团&gt;一天播16集的播出盛况将成为历史. ●广电总局5月推&quot;限播令&quot;,限制卫视频道黄金时段滥播电视剧. ●本报鉴定:这个&quot;限播令&quot;其实是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J7g3z.html" rel="bookmark" class="title">Canonical面向Ubuntu 16&period;04 LTS发布首批内核安全修复补丁</a>
					<div>
						上周我们曾报道Canonical已经开始为运行64位系统和Linux Kernel 4.4 LTS内核的Ubuntu 16.04 LTS(Xenial Xerus)提供在线内核补丁服务,在上周末Can ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYB39b.html" rel="bookmark" class="title">《Core Data应用开发实践指南》一1&period;2　Core Data的适用场合</a>
					<div>
						1.2 Core Data的适用场合 如果应用程序要保存的设置数据太多,以致NSUserDefaults及&quot;特性列表&quot;(property list)这种简单的存储方案无法应付,那么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YQmJp.html" rel="bookmark" class="title">SCX-4821HN不能扫描&comma;但打印正常&comma;如何解决</a>
					<div>
						若机器不能扫描,但打印正常,请按照以下步骤操作: 1. 请确认使用的扫描软件是否三星自带的,若不是,建议点击这里下载扫描软件和点击这里下载扫描驱动(驱动安装:http://www.111cn.net/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm7Xyb.html" rel="bookmark" class="title">Java 访问 C&plus;&plus; 方法 JavaCPP</a>
					<div>
						JavaCPP提供了在Java中高效访问本地C++的方法.采用JNI技术实现,支持所有Java实现包括Android系统,Avian 和 RoboVM. JavaCPP提供了一系列的Annotatio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Ddn8b.html" rel="bookmark" class="title">用el和jstl标签的时候出现的错误</a>
					<div>
						问题描述 在写一个小程序的时候出现的错误错误地方大概是这里&lt;jsp:useBeanid=&quot;articleBo&quot;class=&quot;own.operation.Articl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5OQx7b.html" rel="bookmark" class="title">在线营销就这样开始了&lpar;二&rpar;</a>
					<div>
						今天是新年的11日,朱磊一早的航班从杭州到北京,由于杭州大雾的缘故,晚上9点我们才见上面.约在金源Mall的五楼茶馆,尽管我们往来的邮件和电话无数,都应该清楚这个阶段的业务发展,但见面后仍只是简单寒暄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqODNez.html" rel="bookmark" class="title">MYSQL同步 Slave&lowbar;IO&lowbar;Running&colon; No 或者Slave&lowbar;SQL&lowbar;Running&colon; No的解决方法&lbrack;已测&rsqb;&lowbar;Mysql</a>
					<div>
						今天在测试mysql是否同步时,检查数据库发现一台MySQL Slave未和主机同步,查看Slave状态: mysql&gt; show slave status\G Slave_IO_Running ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Oylqb.html" rel="bookmark" class="title">日媒曝12&period;9英寸巨屏iPad Pro或年底发布</a>
					<div>
						[环球科技综合报道]据日本Livedoor新闻网7月18日报道,拥有12.9英寸巨屏的苹果iPad Pro将于今年年底正式亮相.资料图据报道,新款iPad Pro与iWatch相同,均采用了新一代接触 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPOq8ZM.html" rel="bookmark" class="title">利用施耐德PLC模拟器漏洞可远程控制工作站</a>
					<div>
						本文讲的是利用施耐德PLC模拟器漏洞可远程控制工作站,用于向施耐德电气公司各种工业控制器编辑和部署代码的软件存在漏洞,攻击者可向工业工程软件发送恶意代码,远程控制用于编程和控制PLC(可编程逻辑控制器 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
